//package gom;
import java.io.*;
import java.util.*;
import org._3pq.jgrapht.graph.*;
import org._3pq.jgrapht.edge.*;
import org._3pq.jgrapht.*;

class LineGraph_spe_transf extends DirectedMultigraph  {
public LineGraph_spe_transf() {}
public static OGraph transform(OGraph ogs) {
/* Determiner la liste des noeuds contenu dans le Line Graph specialis */
Object [] Vtx=ogs.vertexSet().toArray();
for(int i=0;i<Vtx.length;i++) {ogs=process(ogs,Vtx[i]);}
return ogs;
}
public static OGraph process(OGraph ogs,Object Node) {

	List EE= new ArrayList();
	List VE= new ArrayList();
	List EB= new ArrayList();
	List VB= new ArrayList();
	EE=End_Edges((OLine)Node,ogs);
	VE=Vertex(EE,Node);
	ogs=process2(ogs,VE.toArray(),Node);
	EB=Begin_Edges((OLine)Node,ogs);
	VB=Vertex(EB,Node);
	ogs=process2(ogs,VB.toArray(),Node);
	return ogs;
}
public static List End_Edges(OLine L,OGraph ogs) {

		List Liste= new ArrayList();
		OPoint end=new OPoint(L.getEnd().getX(),L.getEnd().getY());
		Object[] Lines=ogs.vertexSet().toArray();
		for(int i=0;i<Lines.length;i++)
		{
		OPoint debut=new OPoint(((OLine)Lines[i]).getBegin().getX(),((OLine)Lines[i]).getBegin().getY());
		OPoint fin=new OPoint(((OLine)Lines[i]).getEnd().getX(),((OLine)Lines[i]).getEnd().getY());
		if(((debut.equals(end)) ||(fin.equals(end))) & (!L.equals(Lines[i])))
		{
			if(ogs.containsEdge(ogs.getEdge(L,Lines[i])))
			Liste.add((Object)(ogs.getEdge(L,Lines[i])));
			if(ogs.containsEdge(ogs.getEdge(Lines[i],L)))
			Liste.add((Object)(ogs.getEdge(Lines[i],L)));
		}
		}
			return Liste;
		}
public static List Begin_Edges(OLine L,OGraph ogs) {

	List Liste= new ArrayList();
	OPoint begin=new OPoint(L.getBegin().getX(),L.getBegin().getY());
	Object[] Lines=ogs.vertexSet().toArray();
	for(int i=0;i<Lines.length;i++)
	{
	OPoint debut=new OPoint(((OLine)Lines[i]).getBegin().getX(),((OLine)Lines[i]).getBegin().getY());
	OPoint fin=new OPoint(((OLine)Lines[i]).getEnd().getX(),((OLine)Lines[i]).getEnd().getY());
	if(((debut.equals(begin)) ||(fin.equals(begin))) & (!L.equals(Lines[i])))
	{
		if(ogs.containsEdge(ogs.getEdge(L,Lines[i])))
		Liste.add((Object)(ogs.getEdge(L,Lines[i])));
		if(ogs.containsEdge(ogs.getEdge(Lines[i],L)))
		Liste.add((Object)(ogs.getEdge(Lines[i],L)));
	}
	}
	return Liste;
}
public static List Vertex(List E,Object Node) {

		List V= new ArrayList();
		 for(int i=0;i<E.size();i++)
		 {
			 OLine src=(OLine)(((Edge)E.get(i)).getSource());
			 OLine trg=(OLine)(((Edge)E.get(i)).getTarget());
			 if(src.equals((OLine)Node))
			 V.add(trg);
			 else
			 V.add(src);
		 }
		 return V;
	 }
 public static OGraph process2(OGraph ogs,Object[] V,Object Node) {

	 int size=V.length;
	 for (int i=0;i<size;i++) ogs=compare(ogs,V[i],Node);
	 return ogs;
}
 public static OGraph compare(OGraph ogs, Object V, Object Node) {

	Edge e1=ogs.getEdge(V,Node);
	Edge e2=ogs.getEdge(Node,V);
	double angle1=((OLine)V).getAngle((OLine)Node);
	double angle2=((OLine)Node).getAngle((OLine)V);
	if(angle1==angle2) {ogs.removeEdge(e1);ogs.removeEdge(e2);}
	if(angle1>angle2) ogs.removeEdge(e1);
	if(angle2>angle1) ogs.removeEdge(e2);
	return ogs;
	}
}

