import java.io.*;
import java.util.*;

import org._3pq.jgrapht.graph.*;
import org._3pq.jgrapht.edge.*;
import org._3pq.jgrapht.*;


/**
*   The standard ORelation object
*	@author		K. Zouba
*	@version	07/2005
*/
public class ORelation extends OGraphicImpl  {

private OLine Line;
private String relation;
public ORelation(OLine Line,String relation) {
this.Line=Line;
this.relation=relation;
}
public String getRelation() {
	return relation;
}
/** Copy the OGraphic object */
public  OGraphic copy(){return null;}
/** Define how write a OGraphic object into a gom file */
public void gomWrite(BufferedWriter flow){
	String s=relation;
	try {
	if(s.equals("adjacency")) flow.write("adjacency"+"\n");
	if(s.equals("include")) flow.write("include"+"\n");
	if (s.equals("empty")) flow.write("empty"+"\n");
	}
	catch(IOException e){System.out.println("IOException");}
	}
/** Define how write a OGraphic object into a xml file */
public  void xmlWrite(BufferedWriter flow){}
/** Define how write a OGraphic object into a svg file */
public void svgWrite(BufferedWriter flow){

	try {
		flow.write("<line x1=\""+Line.getBegin().getX()+"\" x2=\""+Line.getEnd().getX()+"\" y1=\""+Line.getBegin().getY()+"\" y2=\""+Line.getEnd().getY()+"\" ");
		if(relation.equals("include")) flow.write("style=\"fill:none; stroke:red; stroke-width:1\"/>\n");
		if(relation.equals("adjacency")) flow.write("style=\"fill:none; stroke:blue; stroke-width:1\"/>\n");
		flow.write("<circle cx=\""+Line.getBegin().getX()+"\" cy=\""+Line.getBegin().getY()+"\" r=\"1\"/>\n");
		flow.write("<circle cx=\""+Line.getEnd().getX()+"\" cy=\""+Line.getEnd().getY()+"\" r=\"1\"/>\n");
		}
	catch(IOException e){System.out.println("IOException");}
	}

/** Define how read a OGraphic object into a gom file */
public  void gomRead(BufferedReader flow){}
/**xgmmlWrite*/
public void xgmmlWrite (BufferedWriter flow) {}

/** Used to obtain the complet class name */
public String getName(){return null;}
/** Used to print OGraphic object properties */
public void print(){}
}
