import java.io.*;
import java.util.*;

/**
*   OHL
*	@author		K.ZOUBA
*	@version	06/2005
*/
public class Region extends OGraphicImpl  {

OHL region=new OHL();
int ymax,ymin,xmax,xmin;
public Region () {
ymax=0;
ymin=0;
xmax=0;
xmin=0;
}
public String getName() {return getClass().getName();}
public void print() {}

	/** gomRead */
	public void gomRead(BufferedReader flow)  {
		region.gomRead(flow);
		}
	/** SvgWrite*/
	public void svgWrite(BufferedWriter flow) {
		region.svgWrite(flow);
	}
	/** xmlWrite */
	public void xmlWrite(BufferedWriter flow) {
		region.xmlWrite(flow);
	}
	/**xgmmlWrite*/
	static public void xgmmlWrite (OGraphic g ,String wName) {}

	public void gomWrite(BufferedWriter flow) {
			try {
				flow.write(getName()+"\n");

				flow.write(region.objSize()+"\n");
				for(int i=0; i<(region.ov).size(); i++)
					((OGraphic)(region.ov).get(i)).gomWrite(flow);

				flow.write((region.av).size()+"\n");
				for(int i=0; i<(region.av).size(); i++)
				((OGraphic)(region.av).get(i)).gomWrite(flow);
				}
			catch(IOException e) {System.out.println("IOException");}
		}
	/** copy */
	public OGraphic copy() {Region o =new Region(); return o;}

	public boolean isAdjacente(Region R2) {

		OHL cycle1=(OHL)(this.region);
		OHL cycle2=(OHL)(R2.region);
		OHL adjacency =new OHL();
		for(int l=0;l<cycle2.objSize();l++)
		{
		if((cycle1.sameObject(((OLine)cycle2.getObj(l))))&&(!adjacency.sameObject(((OLine)cycle2.getObj(l)))))
		adjacency.addObj(cycle2.getObj(l));
		}
		if(adjacency.objSize()>0) return true; return false;
		}

	public boolean isInclude(Region R2) {

		this.min_max();
		R2.min_max();
		if(((R2.xmin<=this.xmin)&&(R2.xmax>=this.xmax))&&((R2.ymin<=this.ymin)&&(R2.ymax>=this.ymax)))
		return true;
		return false;
	}
	public void min_max() {

		OHL cycle=(OHL)(this.region);
		OPoint P1= new OPoint();
		OPoint P2= new OPoint();
		OLine L=(OLine)(cycle.getObj(0));
		P1= L.getBegin();
		P2=L.getEnd();
		this.xmin=P1.getX();this.xmax=P1.getX();this.ymin=P1.getY();this.ymax=P1.getY();
		if(P2.getX()>this.xmax) this.xmax=P2.getX();
		if(P2.getX()<this.xmin) this.xmin=P2.getX();
		if(P2.getY()>this.ymax) this.ymax=P2.getY();
		if(P2.getY()<this.ymin) this.ymin=P2.getY();
		for (int i=1;i<cycle.objSize();i++)
		{
			L=(OLine)(cycle.getObj(i));
			P1= L.getBegin();
			P2=L.getEnd();
			if(P2.getX()>this.xmax) this.xmax=P2.getX();
			if(P2.getX()<this.xmin) this.xmin=P2.getX();
			if(P2.getY()>this.ymax) this.ymax=P2.getY();
			if(P2.getY()<this.ymin) this.ymin=P2.getY();
			if(P1.getX()>this.xmax) this.xmax=P1.getX();
			if(P1.getX()<this.xmin) this.xmin=P1.getX();
			if(P1.getY()>this.ymax) this.ymax=P1.getY();
			if(P1.getY()<this.ymin) this.ymin=P1.getY();
		}
	}




}









