import java.lang.*;
import java.io.*;
import java.util.*;
import org._3pq.jgrapht.graph.*;
import org._3pq.jgrapht.edge.*;
import org._3pq.jgrapht.*;
import java.util.Set;
import java.util.List;

class Search3 {

HashMap eMap = new HashMap();
static OHL cycle= new OHL();
static int var=0;

public static OGraph creation () {

	/* Creation du graphe-arbre */
	OGraph og= new OGraph(false);
	OLine L1 = new OLine(10,10,40,40);
	System.out.println("L1="+L1);
	OLine L2 = new OLine(20,10,30,40);
	System.out.println("L2="+L2);
	OLine L3 = new OLine(50,60,80,50);
	System.out.println("L3="+L3);
	OLine L4 = new OLine(80,60,40,30);
	System.out.println("L4="+L4);
	OLine L5 = new OLine(70,60,40,30);
	System.out.println("L5="+L5);
	/* ajout des Noeuds */
	og.addVertex(L1);
	og.addVertex(L2);
	og.addVertex(L3);
	og.addVertex(L4);
	og.addVertex(L5);
	/* Ajout des arcs */
	og.addEdge(L1,L2,null);
	og.addEdge(L2,L3,null);
	og.addEdge(L3,L4,null);
	og.addEdge(L4,L1,null);
	og.addEdge(L1,L3,null);
	og.addEdge(L2,L5,null);
	og.addEdge(L5,L3,null);
	return og;
	}

	public static boolean Present(OHL o, OLine ext) {

		for(int i=0;i<o.objSize();i++)
		if(ext.equals((OLine)(o.getObj(i))))
		return true;
		return false;
	}

	public static int Fonction1 (OGraph og, OGraphic Node) {
		Object [] V=og.vertexSet().toArray();
		for(int i=0;i<V.length;i++)
		if(((OLine)Node).equals((OLine)V[i]))
		return og.incomingEdgesOf((Object)(V[i])).size();
		return 0;
	}

	public static OLine Fonction2 (OGraph og, OGraphic Node) {
			Object [] V=og.vertexSet().toArray();
			for(int i=0;i<V.length;i++)
			if(((OLine)Node).equals((OLine)V[i]))
			return (OLine)(V[i]);
			return new OLine();
	}




public static OGraphic extremity(Edge e,OGraphic root) {
	if((OGraphic)(e.getSource())==root)
	return (OGraphic)(e.getTarget());
	return (OGraphic)(e.getSource());
}

/* Construction de l'arbre : Etape 1 */

public static OGraph Tree (OGraph og,OGraphic root,int deg) {


	/* Creation de l'arbre */

	OGraph tree = new OGraph(false);

	/* Creer le noeud racine */

	tree.addVertex(root);


	/* Retourner la liste des arcs touchant le noeud fournit en argument */

	List L=og.edgesOf(root);

	/* Recherche des deux noeuds extremits et ajout  la racine */

	for(int i=0;i<deg;i++) {

		OHL obj=new OHL();
		obj.addObj(root);
		OGraphic v1=extremity((Edge)(L.get(i)),root);
		tree.addVertex(v1);
		obj.addObj(v1);
		tree.eMap.put(v1,obj);
		tree.addEdge(root,v1,null);
		}
	return tree;
	}

	/* Methode Parcours */

	public static OGraphic Parcours (OGraphic root,OGraph og,int i) {

		List L=og.edgesOf(root);
		return extremity((Edge)(L.get(i)),root);

	}

	/* Parcours d'arbre prefixe */

	public static void traverse(OGraph og,OGraph tree, OGraphic root,OGraphic Node) {

			var++;
			if(var>2000) return;
			int deg=tree.outDegreeOf(Node);

			if(deg==0) {

				int deg2 =Fonction1(og,Node);

				for (int j=0;j<2;j++)
				{
					Build(og,tree,root,Node,j);
				}
				return;
			}
				else
				{
				for (int i=0;i<2;i++)
				{

				OGraphic new_root=Parcours(root,tree,i);
				traverse(og,tree,root,new_root);
				}
				}
			}


	public static void Build (OGraph og,OGraph tree,OGraphic root,OGraphic Node,int j) {


		OHL o =(OHL)tree.eMap.get((Object)Node);
		OLine P;
		/* Obtenir liste des noeuds du Graphe */
		OLine node=Fonction2(og,Node);
		OGraphic ext=Parcours(node,og,j);
		/* Verifier si cet objet est present ou pas dans l'arbre */
		if(tree.containsVertex(ext))
		{P=(OLine)ext.copy();}
		else
		{P=(OLine)ext;}

		if(ext==root)
		{
			OHL o2=(OHL)(o.copy());
			o2.addObj(ext);
			if((o2.objSize()<2)||(o2.objSize()>10)) return;
			cycle.addObj(o2);

		}

		if(Present(o,(OLine)ext))
		return;


		if(!Present(o,(OLine)ext))
		{
			OHL o2=(OHL)o.copy();
			o2.addObj(Fonction2(og,P));
			tree.addVertex(P);
			tree.addEdge(Node,P,null);
			tree.eMap.put(P,o2);
			traverse(og,tree,root,P);
			return;

		}
	}
	public static OHL filter_cycles (OHL List) {

			List temp= new ArrayList();
			int size=List.objSize();
			for(int i=0;i<size;i++)
			for(int j=i+1;j<size;j++)
			{
			if(((((OHL)List.getObj(i)).sameSet((OHL)List.getObj(j))) &&(!temp.contains(new Integer(j))))
			||
			((OHL)List.getObj(j)).objSize()<3)
			temp.add(new Integer(j));
			}
			LineGraph_spe_build obj= new LineGraph_spe_build();
			temp=obj.sorting(temp);
			for(int k=0;k<temp.size();k++)
			List.removeObj(((Integer)temp.get(k)).intValue());
			return List;
		}



public static void main(String args[])
{

	/* Creation de l'arbre */
	/* Creation d'un LineGraph */
	OHL List = new OHL();
	OGraph og=(OGraph)Read.gomRead("GraphG.gom");
	Object[] Vtx=og.vertexSet().toArray();
	System.out.println("nombre de noeuds dans le graphe= "+Vtx.length);
	Object[] edge=og.edgeSet().toArray();
	System.out.println("nombre d'arcs dans le graphe= "+edge.length);
	for(int i=0;i<Vtx.length;i++)
	if((((OGraphic)Vtx[i]).getName()).equals("OLine"))
	List.addObj((OLine)Vtx[i]);
	System.out.println("taille de la liste apres= "+List.objSize());
	og.loader(List);
	/* Number of nodes into the graph */
	int nb=og.number_of_nodes ();
	System.out.println("number of nodes="+nb);
	long t1,t2;
	t1=new Date().getTime();
	for(int i=0;i<nb-1;i++)
	{
		var=0;
	OGraphic root = og.vertexRead(i);
	System.out.println("racine="+root);
	int deg =og.degree_of_Vertex(root);
	OGraph tree=Tree (og,root,deg);
	traverse(og,tree,root,root);
	}
	cycle=filter_cycles(cycle);

	System.out.println("taille du cycle="+cycle.objSize());
	t2=new Date().getTime();
	long t= t2-t1;
	System.out.println("temps d'execution= "+t);

}
}


