import java.io.*;
import java.util.*;

/**
*   This class generates randomly documents in SVG format.
*	@author		K. Zouba
*	@version	07/2005
**/

public class SvgGenerator {

private static BufferedWriter flow;
private int nbr_shapes;
private int nbr_pt;
private int length;
private int height;
private OHL List;

public SvgGenerator(int length,int height) {
this.length=length;
this.height=height;
}
public void shapes() {
nbr_shapes=new Random().nextInt(10);
}
public void Points() {
nbr_pt=new Random().nextInt(6);
}
public void Write(String wName) {
	try {
		flow = new BufferedWriter (new FileWriter (wName));
		flow.write("<?xml version=\""+1.0+"\"?>"+"\n");
		flow.write("<svg>\n");
		shapes();
		for(int i=0;i<nbr_shapes;i++) {
			Points();
			List=Generate_Points(nbr_pt,length,height);
			Polygon(List);
			List.clear();
		}
		flow.write("</svg>\n");
		flow.close();
		}
		catch(IOException e) {System.out.println("IOException");}
}
public OHL Generate_Points(int n,int L, int H) {

	OHL List=new OHL();
	int X,Y;
	Random obj= new Random();
	for (int i=0;i<n;i++) {

		X=obj.nextInt(L);
		System.out.println("X= "+X);
		Y=obj.nextInt(H);
		System.out.println("Y= "+Y);
		List.addObj(new OPoint(X,Y));
	}
	return List;
}
public void Polygon(OHL List) {

	try {
		flow.write("<polygon points=\"");
		for(int j=0;j<List.objSize()-1;j++)	{

		flow.write(""+((OPoint)(List.getObj(j))).getX()+",");
		flow.write(""+((OPoint)(List.getObj(j))).getY()+",");
		}
		flow.write(""+((OPoint)(List.getObj(List.objSize()-1))).getX()+",");
		flow.write(""+((OPoint)(List.getObj(List.objSize()-1))).getY()+"\" ");
		flow.write("style=\"fill:none; stroke:black; stroke-width:2\"/>\n");
		}
		catch(IOException e) {System.out.println("IOException");}
}
}// end of the class


