//package gom;

import java.io.*;
import java.util.*;

import org._3pq.jgrapht.graph.*;
import org._3pq.jgrapht.edge.*;
import org._3pq.jgrapht.*;


class LineGraph_spe_build2 extends DirectedMultigraph  {


public LineGraph_spe_build2() {}

public static OGraph transform(OGraph og) {

	Object[] List=og.edgeSet().toArray();
	int size=List.length;
	for(int i=0;i<size;i++)
	{
	Edge e=(Edge)List[i];
	boolean b=og.removeEdge(e);
	OLine src=(OLine)e.getSource();
	OLine trg=(OLine)e.getTarget();
	double DA1=src.getAngle(trg);
	double DA2=trg.getAngle(src);
	og.addEdge(src,trg,DA1);
	og.addEdge(trg,src,DA2);
	}
	return og;
}

public static OGraph transform2( OGraph ogs) {

		Object[] Vtx=ogs.vertexSet().toArray();
		Vtx=sort_vertex (Vtx,ogs);
		for (int i=0;i<Vtx.length;i++)
		{
			System.out.println("traitement de la ligne :"+Vtx[i]);
			List  LE=new ArrayList();
			LE=End_Edges((OLine)Vtx[i],ogs);
			if(LE.size()==2)
			ogs=marquage(ogs,LE,2);
			if((LE.size()>1)&&(LE.size()!=2)) {
			LE= sort(LE,ogs);
			ogs=marquage(ogs,LE,1);
			LE=remove(LE,ogs);
			boolean b2=ogs.removeAllEdges(LE);
			}
			List  LB=new ArrayList();
			LB=Begin_Edges((OLine)Vtx[i],ogs);
			if(LB.size()==2)
			ogs=marquage(ogs,LB,2);
			if((LB.size()>1)&&(LB.size()!=2))
			{
			LB= sort(LB,ogs);
			ogs=marquage(ogs,LB,1);
			LB=remove(LB,ogs);
			boolean b1=ogs.removeAllEdges(LB);
			}
		}
		return ogs;
	}

	public static List remove(List L,OGraph ogs) {

		double min=((Double)(ogs.eMap.get(L.get(L.size()-1)))).doubleValue();
		List temp= new ArrayList();
		for(int k=0;k<L.size();k++)
		if((((Double)(ogs.eMap.get(L.get(k)))).doubleValue()) ==min)
		temp.add(new Integer(k));
		L=removeAll(L,temp);
		return L;
	}


public static List sort(List LE,OGraph ogs) {

	List LL=copy(LE);
	int size=LL.size();
	Object tempo;
	if(size==1) return LL;
	if(size==2)
	{
		if(((Double)(ogs.eMap.get(LL.get(0)))).doubleValue()>((Double)(ogs.eMap.get(LL.get(1)))).doubleValue())
		{return LL;}
		else
		{tempo=LL.get(0);LL.set(0,LL.get(1));LL.set(1,tempo);return LL;}
		}
		int kmax;
		for(int i=0;i<size;i++)
		{
			kmax=i;
			for(int j=i+1;j<size;j++)
			{
				if(((Double)(ogs.eMap.get(LL.get(j)))).doubleValue()>((Double)(ogs.eMap.get(LL.get(kmax)))).doubleValue())
				kmax=j;
			}
				tempo=LL.get(kmax);
				Object obj=LL.set(kmax,LL.get(i));
				Object obj2=LL.set(i,tempo);
		}
		return LL;
	}

	public static List End_Edges(OLine L,OGraph ogs) {

		List Liste= new ArrayList();
		OPoint end=new OPoint(L.getEnd().getX(),L.getEnd().getY());
		Object[] Lines=ogs.vertexSet().toArray();
		for(int i=0;i<Lines.length;i++)
		{
			OPoint debut=new OPoint(((OLine)Lines[i]).getBegin().getX(),((OLine)Lines[i]).getBegin().getY());
			OPoint fin=new OPoint(((OLine)Lines[i]).getEnd().getX(),((OLine)Lines[i]).getEnd().getY());
			if(((debut.equals(end)) ||(fin.equals(end))) & (!L.equals(Lines[i])))
			{
				if(ogs.containsEdge(ogs.getEdge(L,Lines[i])))
				Liste.add((Object)(ogs.getEdge(L,Lines[i])));
				if(ogs.containsEdge(ogs.getEdge(Lines[i],L)))
				Liste.add((Object)(ogs.getEdge(Lines[i],L)));
			}
		}
			int size=Liste.size();
			List temp= new ArrayList();
			for(int k=0;k<size;k++)
			if((((Double)(ogs.eMap.get(Liste.get(k)))).doubleValue()) ==100)
			temp.add(new Integer(k));
			Liste=removeAll(Liste,temp);
			return Liste;
	}

	public static List Begin_Edges(OLine L,OGraph ogs) {

	List Liste= new ArrayList();
	OPoint begin=new OPoint(L.getBegin().getX(),L.getBegin().getY());
	Object[] Lines=ogs.vertexSet().toArray();
	for(int i=0;i<Lines.length;i++)
		{
			OPoint debut=new OPoint(((OLine)Lines[i]).getBegin().getX(),((OLine)Lines[i]).getBegin().getY());
			OPoint fin=new OPoint(((OLine)Lines[i]).getEnd().getX(),((OLine)Lines[i]).getEnd().getY());
			if(((debut.equals(begin)) ||(fin.equals(begin))) & (!L.equals(Lines[i])))
			{
				if(ogs.containsEdge(ogs.getEdge(L,Lines[i])))
				Liste.add((Object)(ogs.getEdge(L,Lines[i])));
				if(ogs.containsEdge(ogs.getEdge(Lines[i],L)))
				Liste.add((Object)(ogs.getEdge(Lines[i],L)));
			}
		}
		int size=Liste.size();
		List temp= new ArrayList();
		for(int k=0;k<size;k++)
		if((((Double)(ogs.eMap.get(Liste.get(k)))).doubleValue()) ==100)
		temp.add(new Integer(k));
		Liste=removeAll(Liste,temp);
		return Liste;
	}
public static OGraph marquage (OGraph ogs, List LL,int a) {

	if(a==1) {
	double min=((Double)(ogs.eMap.get(LL.get(LL.size()-1)))).doubleValue();
	for(int i=0;i<LL.size();i++)
	{
		double val=((Double)(ogs.eMap.get(LL.get(i)))).doubleValue();
		if(val==min)
		{
		Edge e= (Edge)LL.get(i);
		ogs.removeEdge(e);
		ogs.addEdge((OLine)e.getSource(),(OLine)e.getTarget(),100);
		}
	}
	}
	if(a==2)
	{
		for(int i=0;i<LL.size();i++)
		{
			Edge e= (Edge)LL.get(i);
			ogs.removeEdge(e);
			ogs.addEdge((OLine)e.getSource(),(OLine)e.getTarget(),100);
		}
	}
	return ogs;
	}

public static List removeAll(List L,List temp) {

	temp=sorting(temp);
	for(int i=0;i<temp.size();i++)
	L.remove(((Integer)temp.get(i)).intValue());
	return L;
	}
public static List sorting(List LL) {

		int size=LL.size();
		Object tempo;
		if(size==2)
		{
			if(((Integer)(LL.get(0))).intValue()>((Integer)(LL.get(1))).intValue())
			{return LL;}
			else
			{tempo=LL.get(0);LL.set(0,LL.get(1));LL.set(1,tempo);return LL;}
		}
		int kmax;
		for(int i=0;i<size;i++)
		{
			kmax=i;
			for(int j=i+1;j<size;j++)
			{
				if(((Integer)(LL.get(j))).intValue()>((Integer)(LL.get(kmax))).intValue())
				kmax=j;
			}
			tempo=LL.get(kmax);
			Object obj=LL.set(kmax,LL.get(i));
			Object obj2=LL.set(i,tempo);
		}
		return LL;
	}

	public static List copy(List L) {

		List LL= new ArrayList();
		for(int i=0;i<L.size();i++)
		{
		Object o=L.get(i);
		boolean c=LL.add(o);
		}
		return LL;
	}

	public void print(OGraph ogt) {

		Object [] list=ogt.edgeSet().toArray();
		for(int i=0;i<list.length;i++)
		{
		Edge e=(Edge)(list[i]);
		OLine src=(OLine)e.getSource();
		OLine trg=(OLine)e.getTarget();
		System.out.println("source:"+src+" , target:"+trg);
	}
	}

	public static Object[] sort_vertex (Object[] Vtx,OGraph ogt) {

		Object tempo;
		int kmin;
		for(int i=0;i<Vtx.length;i++)
			{
				kmin=i;
				for(int j=i+1;j<Vtx.length;j++)
				{
					if(ogt.degree(Vtx[j])<ogt.degree(Vtx[kmin]))
					kmin=j;
				}
				tempo=Vtx[kmin];
				Vtx[kmin]=Vtx[i];
				Vtx[i]=tempo;
				}
		return Vtx;
	}
}

