//package gom;

import java.io.*;
import java.util.*;

import org._3pq.jgrapht.graph.*;
import org._3pq.jgrapht.edge.*;
import org._3pq.jgrapht.*;
class LineGraph_spe_cycles3 extends DirectedMultigraph  {

public LineGraph_spe_cycles3() {}
public OHL cycles(OGraph og) {

	Object [] Vtx=og.vertexSet().toArray();
	OHL List= new OHL();
	LineGraph_spe_transf obj= new LineGraph_spe_transf();
	for (int i=0;i<Vtx.length;i++)
	{
		/* Pour le point de connexion debut*/
		List=Search(List,"begin",Vtx[i],og);
		/* Pour le point de connexion fin */
		List=Search(List,"end",Vtx[i],og);
	}
	return List;
	}

	public static OHL Search(OHL Liste,String orig,Object V,OGraph og) {

		Object root=V;
		Object Node=V;
		OHL cycle= new OHL();
		String origine=orig;
		int outsize=0;
		List outgoing=null;
		LineGraph_spe_transf o= new LineGraph_spe_transf();
		cycle.addObj((OLine)(root));
		boolean vrai=true;
		while(vrai)
		{
			if(orig.equals("begin"))
			{
			outgoing=remove(o.Begin_Edges((OLine)Node,og),og.incomingEdgesOf(Node));
			outsize=outgoing.size();
			}
			if(orig.equals("end"))
				{
				outgoing=remove(o.End_Edges((OLine)Node,og),og.incomingEdgesOf(Node));
				outsize=outgoing.size();
				}

			if(outsize!=0)
			{
				if(outsize==1) Node=(((Edge)outgoing.get(0)).oppositeVertex(Node));
				else Node=min(Node,outgoing,og);
				if((Present(cycle,(OLine)Node)))
				vrai=false;
				if(!(Present(cycle,(OLine)Node))||(((OLine)Node).equals((OLine)root))) cycle.addObj((OLine)Node);
				if(((OLine)Node).equals(((OLine)root))) Liste.addObj(cycle);
				if(!(cycle.objSize()==1)&&(((OLine)cycle.getObj(cycle.objSize()-1)).equals((OLine)root)))
				vrai=false;
				orig=origin(cycle,og);
				cycle=connect(origine,orig,Node,root,cycle,og);
				if(cycle.objSize()==0) vrai=false;
				else if(((OLine)(cycle.getObj(0))).equals( ((OLine)(cycle.getObj(cycle.objSize()-1)))))
				{Liste.addObj(cycle);vrai=false;}


			}
			/* Ajouter une condition else if */
			else vrai =false;
			}
		return Liste;
	}

	public static OHL connect(String origine,String orig,Object Node,Object root,OHL cycle,OGraph og) {

		List Point= new ArrayList();
		Object [] Vtx=og.vertexSet().toArray();
		OPoint Node_point= new OPoint();
		OPoint root_begin=((OLine)root).getBegin();
		OPoint root_end=((OLine)root).getEnd();
		if(orig.equals("begin"))
		Node_point=((OLine)Node).getBegin();
		if(orig.equals("end"))
		Node_point=((OLine)Node).getEnd();
		if(((Node_point).equals(root_begin))||((Node_point).equals(root_end)))
		{cycle.addObj((OLine)root);return cycle;}
		for(int i=0;i<Vtx.length;i++)
		{
			OPoint Vtx_begin=((OLine)Vtx[i]).getBegin();
			OPoint Vtx_end=((OLine)Vtx[i]).getEnd();
			if(((Vtx_begin.equals(Node_point))||(Vtx_end.equals(Node_point)))&&(!((OLine)Vtx[i]).equals((OLine)Node)))
			Point.add(Vtx[i]);
		}
		for (int j=0;j<Point.size();j++)
		{
			if(origine.equals("begin"))
			{
				if(((OLine)Point.get(j)).isConnected_end((OLine)root))
				{
					cycle.addObj(((OLine)Point.get(j)));cycle.addObj((OLine)root);j=Point.size();
				}
				else if(((OLine)Point.get(j)).isConnected_begin((OLine)root)) cycle.objClear();
			}

			if(origine.equals("end"))
			{
				if(((OLine)Point.get(j)).isConnected_begin((OLine)root))
				{
					cycle.addObj(((OLine)Point.get(j)));cycle.addObj((OLine)root);j=Point.size();
				}
				else if(((OLine)Point.get(j)).isConnected_end((OLine)root)) cycle.objClear();
			}
		}

		return cycle;
	}

	public static Object point(String orig,Object Node,Object root) {

		OPoint root_begin=((OLine)root).getBegin();
		OPoint root_end=((OLine)root).getEnd();
		OPoint Node_begin=((OLine)Node).getBegin();
		OPoint Node_end=((OLine)Node).getEnd();

		if(orig.equals("begin"))
		{
			if((Node_begin.equals(root_begin))||(Node_begin.equals(root_end)))
			Node=root;
		}
		if(orig.equals("end"))
		{
			if((Node_end.equals(root_begin))||(Node_end.equals(root_end)))
			Node=root;
		}
		return Node;
	}
	public static List remove(List L,List V) {

		int k;
		List temp=new ArrayList();
		List LE=copy(L);
		for(int i=0;i<V.size();i++)
		if(LE.contains(V.get(i))) {k=LE.lastIndexOf(V.get(i));temp.add(new Integer(k));}
		temp=sorting(temp);
		for(int j=0;j<temp.size();j++)
		LE.remove(((Integer)temp.get(j)).intValue());
		return LE;
	}
	public static boolean Present(OHL o, OLine ext) {
				for(int i=0;i<o.objSize();i++)
				if(ext.equals((OLine)(o.getObj(i))))
				return true;
				return false;
	}

	public static String origin(OHL cycle,OGraph ogt) {

			String end="end",begin="begin";
			OLine last=(OLine)cycle.getObj(cycle.objSize()-1);
			OLine prev=(OLine)cycle.getObj(cycle.objSize()-2);
			if(((last.getBegin()).equals(prev.getBegin())) ||((last.getBegin()).equals(prev.getEnd())))
			return end;
			return begin;
	}

	public static List copy(List L) {

			List LL= new ArrayList();
			for(int i=0;i<L.size();i++) {
			Object o=L.get(i);
			boolean c=LL.add(o);
			}
			return LL;
	}

	public static List sort(List LE,OGraph ogs) {

		List LL=copy(LE);
		int size=LL.size();
		Object tempo;
		if(size==1) return LL;
		if(size==2)
		{
			if(((Double)(ogs.eMap.get(LL.get(0)))).doubleValue()>((Double)(ogs.eMap.get(LL.get(1)))).doubleValue())
			{return LL;}
			else
			{tempo=LL.get(0);LL.set(0,LL.get(1));LL.set(1,tempo);return LL;}
			}
			int kmax;
			for(int i=0;i<size;i++)
			{
				kmax=i;
				for(int j=i+1;j<size;j++)
				{
					if(((Double)(ogs.eMap.get(LL.get(j)))).doubleValue()>((Double)(ogs.eMap.get(LL.get(kmax)))).doubleValue())
					kmax=j;
				}
					tempo=LL.get(kmax);
					Object obj=LL.set(kmax,LL.get(i));
					Object obj2=LL.set(i,tempo);
			}
			return LL;
	}

	public static List sorting(List LL) {

			int size=LL.size();
			Object tempo;
			if(size==2)
			{
				if(((Integer)(LL.get(0))).intValue()>((Integer)(LL.get(1))).intValue())
				{return LL;}
				else
				{tempo=LL.get(0);LL.set(0,LL.get(1));LL.set(1,tempo);return LL;}
			}
			int kmax;
			for(int i=0;i<size;i++)
			{
				kmax=i;
				for(int j=i+1;j<size;j++)
				{
					if(((Integer)(LL.get(j))).intValue()>((Integer)(LL.get(kmax))).intValue())
					kmax=j;
				}
				tempo=LL.get(kmax);
				Object obj=LL.set(kmax,LL.get(i));
				Object obj2=LL.set(i,tempo);
			}
			return LL;
	}

	public static Object min (Object Node,List L,OGraph og) {

		List LE=sort(L,og);
		Edge e=(Edge)(LE.get(LE.size()-1));
		Object Vertex=e.oppositeVertex(Node);
		return Vertex;
	}

	public OHL filter_cycles (OHL List) {

		List temp= new ArrayList();
		int size=List.objSize();
		for(int i=0;i<size;i++)
		for(int j=i+1;j<size;j++)
		if((((OHL)List.getObj(i)).sameSet((OHL)List.getObj(j))) &&(!temp.contains(new Integer(j))))
		temp.add(new Integer(j));
		LineGraph_spe_build obj= new LineGraph_spe_build();
		temp=obj.sorting(temp);
		for(int k=0;k<temp.size();k++)
		List.removeObj(((Integer)temp.get(k)).intValue());
		return List;
		}
}