import java.io.*;

/**
* 	OGraphicImpl is a default implementation
*	of OGraphic interface.
*	@author		M. Delalandre, K. Zouba
*	@version	05/2005
*/
public abstract class OGraphicImpl implements OGraphic {

	public String getName() {return getClass().getName();}

	/**
	* Used to print OGraphic object properties,
	* this method calls the xmlWrite method
	* and display the results to screen
	*/
	public void print() {
		try {
			BufferedWriter out = new BufferedWriter(new OutputStreamWriter(System.out));
			xmlWrite(out);
			out.close();
			}
		catch(IOException e) {System.out.println("IOException");}
		};
	}