//package gom.std;

import java.io.*;

/**
*   Junction  point object
*	@author		N. Ramangaseheno
*	@version	05/2005
*/
public class OJunction  extends OPoint {

	/**  Constructor without args */
 	public OJunction()	{
 		super();
 		}

	/**  Constructor with int */
 	public OJunction(int x, int y)	{
 		super(x,y);
 		}

 	/**  Constructor with OPoint */
 	public OJunction(OPoint p) {
 		super(p.getX(),p.getY());
 		}

 	/** Define how to write a OExtremity object into a svg file */
	public void svgWrite(BufferedWriter flow) {
	 		try {flow.write("<line x1=\""+getX()+"\" y1=\""+getY()+"\" x2=\""+(getX()+1)+"\" y2=\""+getY()+"\" style=\"fill:none; stroke:red; stroke-width:1\"/>\n");}
	 		catch(IOException e) {System.out.println("IOException");}
 		}
 	}