import java.io.*;
import java.util.*;

/**
*   This class generates randomly documents in SVG format.
*	@author		K. Zouba
*	@version	07/2005
**/

public class RectGenerator {

private static BufferedWriter flow;
private int nbr_shapes;
private int nbr_pt;
private int length;
private int height;
private OHL List;

public RectGenerator(int length,int height) {
this.length=length;
this.height=height;
}
public void shapes() {
nbr_shapes=new Random().nextInt(8);
}
public void Write(String wName) {
	try {
		flow = new BufferedWriter (new FileWriter (wName));
		flow.write("<?xml version=\""+1.0+"\"?>"+"\n");
		flow.write("<svg>\n");
		shapes();
		for(int i=0;i<nbr_shapes;i++) {
			List=features(length,height);
			Rectangle(List);
			List.clear();
		}
		flow.write("</svg>\n");
		flow.close();
		}
		catch(IOException e) {System.out.println("IOException");}
}
public OHL features(int L, int H) {

	OHL List=new OHL();
	List.clear();
	int X,Y,width,height;
	Random obj= new Random();
	X=obj.nextInt(L);
	Y=obj.nextInt(H);
	List.addObj(new OPoint(X,Y));
	width=obj.nextInt(L);
	while(X+width>L)
	width=obj.nextInt(L);
	height=obj.nextInt(H);
	while(Y+height>H)
	height=obj.nextInt(H);
	List.addObj(new OPoint(width,height));

	return List;
}
public void Rectangle(OHL List) {

	try {
			flow.write("<rect x=\""+((OPoint)List.getObj(0)).getX()+"\" y=\""+((OPoint)List.getObj(0)).getY()+"\" width=\""+((OPoint)List.getObj(1)).getX()+"\" height=\""+((OPoint)List.getObj(1)).getY()+"\" style=\"fill:none; stroke:green; stroke-width:2\"/>\n");
		}
		catch(IOException e) {System.out.println("IOException");}
}
}// end of the class


