//package gom;

import java.io.*;
import java.util.*;

import org._3pq.jgrapht.graph.*;
import org._3pq.jgrapht.edge.*;
import org._3pq.jgrapht.*;

class finding_cycles extends DirectedMultigraph  {

public finding_cycles() {}

public OHL cycles (OGraph ogs) {

	OHL List= new OHL();
	Object root=null;
	Object Node=null;
	/* Liste des Noeuds du LineGraphe specialis */
	Object [] Vtx=ogs.vertexSet().toArray();
	/* Pour chaque noeud */
	for (int i=0;i<Vtx.length;i++)
	{
		/* Pour le point de connexion fin */
		root=Vtx[i];
		OHL cycle_e= new OHL();
		cycle_e.addObj((OLine)(root));
		List  LE=new ArrayList();
		LE=End_Edges((OLine)Vtx[i],ogs);
		LE=sort(LE,ogs);
		Edge src_e=(Edge)(LE.get(LE.size()-1));
		if(src_e.getSource()==root)
		{
			cycle_e.addObj((OLine)src_e.getTarget());
			Node=src_e.getTarget();
			List= process(List,Node,root,ogs,cycle_e,"end");
		}

		/* Pour le point de connexion debut */
		OHL cycle_b= new OHL();
		cycle_b.addObj((OLine)(root));
		List  LB=new ArrayList();
		LB=Begin_Edges((OLine)Vtx[i],ogs);
		LB=sort(LB,ogs);
		Edge src_b=(Edge)(LB.get(LB.size()-1));
		if(src_b.getSource()==root)
		{
			cycle_b.addObj((OLine)src_b.getTarget());
			Node=src_b.getTarget();
			List= process(List,Node,root,ogs,cycle_b,"begin");
		}
	}

return List;
}

	public static OHL process(OHL List,Object Node,Object root,OGraph ogs,OHL cycle,String point) {

		while(!((OLine)Node).equals(((OLine)root)))
		{

			String orig=origin(cycle,ogs);
			if(orig.equals("end"))
			{
			List  LE=new ArrayList();
			LE=End_Edges((OLine)Node,ogs);
			if(LE.size()==2) {Node=(((Edge)LE.get(0)).oppositeVertex(Node));}
			if(LE.size()>2)
			{
			LE=sort(LE,ogs);
			Edge e=(Edge)(LE.get(LE.size()-1));
			List list=new ArrayList();
			list.add(e.getSource());
			list.add(e.getTarget());
			list=remove(list,Node);
			Node=list.get(0);
			}
			}

			if(orig.equals("begin"))
			{
				List  LB=new ArrayList();
				LB=Begin_Edges((OLine)Node,ogs);
				if(LB.size()==2) {Node=(((Edge)LB.get(0)).oppositeVertex(Node));}
				if(LB.size()>2)
				{
					LB=sort(LB,ogs);
					Edge e=(Edge)(LB.get(LB.size()-1));
					List list=new ArrayList();
					list.add(e.getSource());
					list.add(e.getTarget());
					list=remove(list,Node);
					Node=list.get(0);
				}
			}
			if(!(Present(cycle,(OLine)Node))||(((OLine)Node).equals((OLine)root))) cycle.addObj((OLine)Node);
			cycle.addObj((OLine)Node);
			if(((OLine)Node).equals(((OLine)root)))
			{
				String direct=origin(cycle,ogs);
				if(direct.equals(point))
				List.addObj(cycle);
			}
			}
			return List;

}
	public static boolean Present(OHL o, OLine ext) {
			for(int i=0;i<o.objSize();i++)
			if(ext.equals((OLine)(o.getObj(i))))
			return true;
			return false;
	}

	public static List remove(List list,Object Node) {

	for (int j=0;j<list.size();j++)
	{if(((OLine)list.get(j)).equals((OLine)Node)) list.remove(j); j=list.size();}
	return list;
	}

	public static String origin(OHL cycle,OGraph ogt) {

		String end="end",begin="begin";
		OLine last=(OLine)cycle.getObj(cycle.objSize()-1);
		OLine prev=(OLine)cycle.getObj(cycle.objSize()-2);
		if(((last.getBegin()).equals(prev.getBegin())) ||((last.getBegin()).equals(prev.getEnd())))
		return end;
		return begin;
	}


	public static List End_Edges(OLine L,OGraph ogs) {

		List Liste= new ArrayList();
		OPoint end=new OPoint(L.getEnd().getX(),L.getEnd().getY());
		Object[] Lines=ogs.vertexSet().toArray();
		for(int i=0;i<Lines.length;i++)
		{
			OPoint debut=new OPoint(((OLine)Lines[i]).getBegin().getX(),((OLine)Lines[i]).getBegin().getY());
			OPoint fin=new OPoint(((OLine)Lines[i]).getEnd().getX(),((OLine)Lines[i]).getEnd().getY());
			if(((debut.equals(end)) ||(fin.equals(end))) & (!L.equals(Lines[i])))
			{
				if(ogs.containsEdge(ogs.getEdge(L,Lines[i])))
				Liste.add((Object)(ogs.getEdge(L,Lines[i])));
			}
		}

			return Liste;
}

		public static List Begin_Edges(OLine L,OGraph ogs) {

			List Liste= new ArrayList();
			OPoint begin=new OPoint(L.getBegin().getX(),L.getBegin().getY());
			Object[] Lines=ogs.vertexSet().toArray();
			for(int i=0;i<Lines.length;i++)
				{
					OPoint debut=new OPoint(((OLine)Lines[i]).getBegin().getX(),((OLine)Lines[i]).getBegin().getY());
					OPoint fin=new OPoint(((OLine)Lines[i]).getEnd().getX(),((OLine)Lines[i]).getEnd().getY());
					if(((debut.equals(begin)) ||(fin.equals(begin))) & (!L.equals(Lines[i])))
					{
						if(ogs.containsEdge(ogs.getEdge(L,Lines[i])))
						Liste.add((Object)(ogs.getEdge(L,Lines[i])));

					}
				}
				return Liste;
	}


	public static List sort(List LE,OGraph ogs) {

		List LL=copy(LE);
		int size=LL.size();
		Object tempo;
		if(size==1) return LL;
		if(size==2)
		{
			if(((Double)(ogs.eMap.get(LL.get(0)))).doubleValue()>((Double)(ogs.eMap.get(LL.get(1)))).doubleValue())
			{return LL;}
			else
			{tempo=LL.get(0);LL.set(0,LL.get(1));LL.set(1,tempo);return LL;}
			}
			int kmax;
			for(int i=0;i<size;i++)
			{
				kmax=i;
				for(int j=i+1;j<size;j++)
				{
					if(((Double)(ogs.eMap.get(LL.get(j)))).doubleValue()>((Double)(ogs.eMap.get(LL.get(kmax)))).doubleValue())
					kmax=j;
				}
					tempo=LL.get(kmax);
					Object obj=LL.set(kmax,LL.get(i));
					Object obj2=LL.set(i,tempo);
			}
			return LL;
	}
	public static List copy(List L) {

			List LL= new ArrayList();
			for(int i=0;i<L.size();i++)
			{
			Object o=L.get(i);
			boolean c=LL.add(o);
			}
			return LL;
	}

}